#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<fcntl.h>
#include "code0.h"
#include "code1.h"
#include "code2.h"
#define UNKNOW 0
#define FAT16 1
#define FAT32 2
#define NTFS 3
int main(int argc,char *argv[])
{
	FILE *fp;
	long len,curpos;
	unsigned char bc,type,typestr[6],code3[16]={5,0,0x47,0,0x32,0,0x4c,0,0x44,0,0x52,0,0,0,0,0};
	unsigned short mask;
	mask=0xaa55;
	if(argc==2)
	{
		fp=NULL;
		fp=fopen(argv[1],"w+b");
		if(fp==NULL)
		{
			printf("Can't open device file!\n");
			return -1;
		}
		else
		{
			curpos=0x36;
			fseek(fp,curpos,SEEK_SET);
			len=fread((void *)typestr,1,5,fp);
			typestr[5]=0;
			if(strcmp(typestr,"FAT16")==0) type=FAT16;
			else
			{
				curpos=0x52;
				fseek(fp,curpos,SEEK_SET);
				len=fread((void *)typestr,1,5,fp);
				typestr[5]=0;
				if(strcmp(typestr,"FAT32")==0) type=FAT32;
				else
				{
					curpos=0x03;
					fseek(fp,curpos,SEEK_SET);
					len=fread((void *)typestr,1,4,fp);
					typestr[4]=0;
					if(strcmp(typestr,"NTFS")==0) type=NTFS;
					else type=UNKNOW;
				}
			}
			if(type==FAT16)
			{
				printf("Partition type is FAT16.\n");
				curpos=0x3e;
				fseek(fp,curpos,SEEK_SET);
				len=fwrite((void *)code0,1,448,fp);
			}
			else if(type==FAT32)
			{
				printf("Partition type is FAT32.\n");
				curpos=0x5a;
				fseek(fp,curpos,SEEK_SET);
				len=fwrite((void *)code1,1,400,fp);
				curpos=0x1800;
				fseek(fp,curpos,SEEK_SET);
				len=fwrite((void *)code2,1,512,fp);
				curpos=0x19fe;
				fseek(fp,curpos,SEEK_SET);
				len=fwrite((void *)&mask,2,1,fp);
			}
			else if(type==NTFS)
			{
				printf("Partition type is NTFS.\n");
				curpos=0x200;
				fseek(fp,curpos,SEEK_SET);
				len=fread((void *)&bc,1,1,fp);
				fseek(fp,curpos,SEEK_SET);
				len=fwrite((void *)code3,1,(bc+1)*2,fp);
			}
			else
			{
				printf("Unknow partition type.\n");
				return -1;
			}
			fclose(fp);
			return 0;
		}
	}
	else
	{
		printf("Please input device name!\n");
		return -1;
	}
}
